/***************************************************************************
 *            httpd.c
 *
 *  Wed Jun 14 21:52:16 2006
 *  Copyright  2006  User
 *  Email
 ****************************************************************************/

#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <avr/io.h>
#include <avr/wdt.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../net/network.h"
#include "../hardware/uart.h"
#include "../hardware/timer1.h"

#include "httpd.h"

unsigned int visitCounter=0;

void httpd_init()
	{
		RegisterTCPPort( HTTPD_PORT );
		printf_P( PSTR("HTTP-Server gestartet auf Port %d.\n\r") ,HTTPD_PORT);
	}

unsigned int  httpd_thread()

	{
		volatile unsigned int SOCKET,i;
		
		volatile unsigned char *httpdbuffer;
 		httpdbuffer = (volatile unsigned char *) __builtin_alloca (( size_t ) HTTPD_BUFFER );
		
		volatile unsigned char HTTP_REQ = 0 ;
		volatile unsigned int datalen;		

		// schau mal ob ein Verbindung auf Port 80 geöffnet wurde
		
		SOCKET = CheckPortRequest( HTTPD_PORT );
		
		// Wenn Verbindung auf Port 80 weiter, sonst abbruch und zurück
		
		if ( SOCKET != 0xffff )
		{
			while( CheckSocketState ( SOCKET ) != 0 )
			{
				datalen = GetSocketNextLine( SOCKET, HTTPD_BUFFER , httpdbuffer );
				if ( datalen != 0)
				{
					if ( !memcmp( httpdbuffer , "GET /" , 5 ) )
					{					
						if ( httpdbuffer[5] != ' ' ) 
						{
							HTTP_REQ = 2 ;
						}
						else
						{
							HTTP_REQ = 1 ;
							visitCounter++;
						}
					}
					if ( ( httpdbuffer[ 0 ] == '\r' ) && ( httpdbuffer[ 1 ] == '\n' ) || ( httpdbuffer[ 1 ] == '\r' ) && ( httpdbuffer[ 2 ] == '\n' ) )
					{
						if ( HTTP_REQ == 2 )
						{
							CloseTCPSocket( SOCKET );							
						}
						else
						{
						static const char HTTP_OK1[] PROGMEM= {
								"HTTP/1.0 200\r\n"
								"Content-Type: text/html\r\n"
								"Keep-Alive: close\r\n"
								"\r\n"
								"<HTML>\r\n"
								"<HEAD>\r\n"
								"<meta http-equiv=\"refresh\" content=\"20; \">\r\n"
								"<TITLE>Winkewinke</TITLE>\r\n"
								"</HEAD>\r\n"
								"<BODY>\r\n" };
						PutSocketData_P( SOCKET, strlen_P( HTTP_OK1 ) , HTTP_OK1 );

						sprintf_P( httpdbuffer , PSTR("Zeit: %02d:%02d:%02d.%02d<BR>"),hh,mm,ss,ms);
						PutSocketData( SOCKET, strlen( httpdbuffer ), httpdbuffer );
						wdt_reset();

						sprintf_P( httpdbuffer, PSTR("Ethernet: %ld Bytes "), ByteCounter);
						PutSocketData( SOCKET, strlen( httpdbuffer ), httpdbuffer );

						sprintf_P( httpdbuffer, PSTR("in %ld Packets<BR>\r\n"), PacketCounter );
						PutSocketData( SOCKET, strlen( httpdbuffer ), httpdbuffer );

						sprintf_P( httpdbuffer, PSTR("Du bist der %d. Besucher auf Socket %d.<BR>\r\n"), visitCounter, SOCKET );
						PutSocketData( SOCKET, strlen( httpdbuffer ), httpdbuffer );

						static const char HTTP_OK2[] PROGMEM= {
								"</BODY>\r\n"
								"</HTML>\r\n"
								"\r\n"	};
						PutSocketData_P( SOCKET, strlen_P( HTTP_OK2 ), HTTP_OK2 );
								
						CloseTCPSocket( SOCKET );
						}
						break;
					} 
					datalen = 0;
				}
			}
			return( 1 );
		}
		else
		{
		return( 0 );
		}
	}
