/***************************************************************************
 *            ntp.c
 *
 *  Mon Aug 28 11:36:49 2006
 *  Copyright  2006  User
 *  Email
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include <avr/pgmspace.h>
#include <stdio.h>
#include <stdlib.h>
#include <avr/interrupt.h>
#include "../hardware/timer1.h"
#include "../hardware/uart.h"
#include "dns.h"
#include "ip.h"
#include "tcp.h"
#include "ntp.h"

unsigned int NTP_GetTime( void )
	{
		unsigned char * buffer;
		buffer = (unsigned char*) __builtin_alloca (( size_t ) 32 );

		unsigned int i,SOCKET;
		unsigned long IP = 0x0a018582, Zeit,Std,Min,Sek ;
	
		union DATE ZeitInSek;
	
		// Hoste nach Ip auflösen
		sprintf_P( buffer, PSTR("time.fu-berlin.de"));
		IP = DNS_ResolveName( buffer );
		// könnte er aufgelöst werden ?
		if ( IP == DNS_NO_ANSWER ) return( NTP_ERROR );

		i = 0;

		while( 1 )
		{
			// mit IP auf Port 37 verbinden
			SOCKET = Connect2IP( IP, 37);
			// Verbindung okay ?
			if ( SOCKET != SOCKET_NOT_USE ) break;				
			if ( i > MAX_NTP_FAILED ) return( NTP_ERROR );
			i++;
		}
		
		while ( 1 )
		{
			i = GetSocketData( SOCKET, 4, buffer );
			// Wenn Daten empfangen, das weiter
			if ( i != 0 )
			{
				for ( i = 0 ; i < 4 ; i++ ) ZeitInSek.DateByte[ i ] = buffer[ 3 - i ];
				ZeitInSek.Date = ZeitInSek.Date + TimeZone;
				ZeitInSek.Date = ZeitInSek.Date % SecondsPerDay;
				Std = ZeitInSek.Date / SecondsPerHour;
				ZeitInSek.Date = ZeitInSek.Date - ( Std * 3600 );
				Min = ZeitInSek.Date / SecondsPerMin;
				Sek = ZeitInSek.Date % SecondsPerMin;

				cli();
				hh = Std;
				mm = Min;
				ss = Sek;
				sei();
				
				CloseTCPSocket( SOCKET );
				return( NTP_OK );
			}
		}
	}
